import os
import glob
import subprocess
import time

def find_between( s, first, last ):
    try:
        start = s.index( first ) + len( first )
        end = s.index( last, start )
        return s[start:end]
    except ValueError:
        return ""

os.chdir("/Users/jorge_cmata/Documents/workspace/cloudclient")

#PARAMETERS
total_time_taken = 0
total_time_taken_subprocess = 0
total_number_of_chunks = 0
total_chunk_average = 0
total_forced = 0
total_times_hash = 0
total_dedup_blocks = 0
start = time.time()

filelist = glob.glob("/Users/jorge_cmata/Documents/workspace/cloudclient/batch3/*")

for i in range(len(filelist)):
	filename = filelist[i].split("cloudclient/",1)[1]
	start1 = time.time()
	out = subprocess.check_output(["./cloudclient", filename , "/Users/jorge_cmata/Documents/workspace/cloudclient/traces/storage_key.txt", "lb"], stdin=subprocess.PIPE)
	end1 = time.time()
	total_time_taken_subprocess = total_time_taken_subprocess + float(end1-start1)
	#Time taken
	timeTakenExists = out.find("Time taken")
	if timeTakenExists!=-1:
		time_taken = find_between( out, "Time taken: ", " ||" )
	 	total_time_taken = total_time_taken + float(time_taken)

	#number of chunks
	number_of_chunks = find_between( out, "Number of chunks: ", " ||" )
	total_number_of_chunks = total_number_of_chunks + float(number_of_chunks)

	#chunk average
	chunk_average = find_between( out, "Chunk size average: ", " ||" )
	total_chunk_average = (total_chunk_average*(total_number_of_chunks-float(number_of_chunks)) + float(chunk_average)*float(number_of_chunks))/total_number_of_chunks

	#Number of forced chunks
	forcedChunksExists = out.find("Number of forced chunks ")
	if forcedChunksExists!=-1:
		number_forced = find_between( out, "Number of forced chunks ", " ||" )
	 	total_forced = total_forced + float(number_forced)

	#Number of times hash function
	hashFunctionExists = out.find("Number of times hash function ")
	if hashFunctionExists!=-1:
		number_times_hash = find_between( out, "Number of times hash function ", " ||" )
	 	total_times_hash = total_times_hash + float(number_times_hash)

	#deduplicated blocks
	number_of_dedup_blocks = find_between( out, "Number of deduplicated blocks: ", " ||" )
	total_dedup_blocks = total_dedup_blocks + float(number_of_dedup_blocks)
	
	position = i + 1
	print("------------------- " + str(position) + " / " + str(len(filelist)) + " -------------------")

end = time.time()
print(end - start)

print "------GLOBAL RESULTS --------"
print "Total time taken: " + str(total_time_taken)
print "Total time taken: " + str(total_time_taken_subprocess)
print "Total number of blocks: " + str(total_number_of_chunks)
print "Chunk size average: " + str(total_chunk_average)
print "Total number of forced chunks: " + str(total_forced)
print "Total number of times hash function: " + str(total_times_hash)
print "Total number of deduplicated blocks: " + str(total_dedup_blocks)


