<?php

include "tree.php";

ini_set('memory_limit', '-1');

$GLOBALS['tree'] = new Tree();
$GLOBALS['wholeFileDedup'] = true;
$GLOBALS['blockDedup'] = 0;

if($_SERVER['REQUEST_METHOD'] == "POST"){
	//Retrieving data passed over Internet and decoding json
    $data = json_decode(file_get_contents('php://input'), true);
    store_file($data);

}else if($_SERVER['REQUEST_METHOD'] == "GET"){
	echo "GET";
}

/************************************************/
/******************* FUNCTIONS ******************/
/************************************************/


/*************** MAIN FUNCTIONS *****************/

function store_file($data) {
	$block_sizes = array();
    //Set MySQL connection 
    $conn = mysql_connect('127.0.0.1', 'root', 'jcm93');
	if (!$conn) {
	    die('Could not connect: ' . mysql_error());
	}

    //Create database (if it doesn't exist previously)
    create_database($conn);
    //Create table (if it doesn't exist previously)
    create_table($conn);
    //Create table trees (if it doesn't exist previously)
    create_table_trees($conn);

    foreach($data as $block){
    	$tag = $block['tag'];
    	$content = $block['content'];
    	add_row($conn, $tag, $content);

    	//Storage graph attack
    	$block_sizes[] = strlen($content);
    }

    /*** ATTACK ****/
    check_if_table_exists('Trees', $conn);
    $trees = array();
    $trees = get_trees($conn);
    $collision_counter = 0;
    foreach($trees as $tree){
    	$tree_unserialized = unserialize($tree);
    	if($tree_unserialized->hasSameFingerprint($block_sizes)){
    		$collision_counter++;
    	}
    }
    echo "Number of collisions: " . $collision_counter . " || \n";
    /***************/

    if(!$GLOBALS['wholeFileDedup']){
    	add_tree($conn, $GLOBALS['tree']);
    }

    mysql_close($conn);
    if($GLOBALS['wholeFileDedup']){
    	echo "wholeFileDedup\n";
    }
    echo "Number of deduplicated blocks: " . $GLOBALS['blockDedup'] . " ||";

    echo "Done.\n";
}


/****************AUXILIARY FUNCTIONS *************/

//Create a database from a MySQL connection
function create_database($conn){
	// Make my_db the current database
	$db = mysql_select_db('server_database', $conn);

	if (!$db) {
	  // If we couldn't, then it either doesn't exist, or we can't see it.
	  $sql = 'CREATE DATABASE server_database';

	  if (mysql_query($sql, $conn)) {
	      echo "Database server_database created successfully\n";
	  } else {
	      echo 'Error creating database: ' . mysql_error() . "\n";
	  }
}

//Create a table from a MySQL connection
function create_table($conn){
	//Sql sentence
	$sql = "CREATE TABLE IF NOT EXISTS server_database.StoredBlocks (
			tag VARCHAR(255) NOT NULL PRIMARY KEY, 
			content MEDIUMTEXT NOT NULL
			)";

	if (mysql_query($sql, $conn)) {
	    echo "Table StoredBlocks created successfully\n";
	} else {
	    echo "Error creating table: " . mysql_error() . "\n";
	}
}

//Add row into the table if the tag doesn't exist previously
function add_row($conn, $tag, $content){
	//Preventing SQL injection
	$tag = mysql_real_escape_string($tag);
	$content = mysql_real_escape_string($content);

	//Deduplication
	$sql = "INSERT INTO server_database.StoredBlocks (tag, content) VALUES ('$tag', '$content') ON DUPLICATE KEY UPDATE tag=tag;";

	/*****STORAGE TREE*******/
	//Create the new leaf
	$leaf = new Leaf();
	$leaf->setId($tag);
	$leaf->setSize(strlen($content));
	$GLOBALS['tree']->addLeaf($leaf);
	/**************************/

	if (mysql_query($sql, $conn)) {
		if(mysql_affected_rows($conn) != 0){
			$GLOBALS['wholeFileDedup'] = false;
		} else {
			$GLOBALS['blockDedup']++;
		}
	} else {
	    echo "Error: " . $sql . "<br>" . mysql_error() . "\n";
	}
}

function add_tree($conn){

	$tree_serialized = serialize($GLOBALS['tree']);
	$tree_serialized = mysql_real_escape_string($tree_serialized);

	$sql = "INSERT INTO server_database.Trees (tree) VALUES ('$tree_serialized')";

	if (mysql_query($sql, $conn)) {
		} else {
		    echo "Error: " . $sql . "<br>" . mysql_error() . "\n";
		}
}

//Create table trees from a MySQL connection
function create_table_trees($conn){
	//Sql sentence
	$sql = "CREATE TABLE IF NOT EXISTS server_database.Trees (
			id INT(11) NOT NULL AUTO_INCREMENT PRIMARY KEY, 
			tree LONGTEXT NOT NULL
			)";

	if (mysql_query($sql, $conn)) {
	} else {
	    echo "Error creating table: " . mysql_error() . "\n";
	}
}

//Retrieve table trees
function get_trees($conn){

	$sql = "SELECT tree FROM server_database.Trees";
	$result = mysql_query($sql);
	if(!$result){
		die ('Cannot retrieve trees');
	}
	$treeArray = Array();
	while ($row = mysql_fetch_array($result)) {
    	$treeArray[] =  $row['tree'];  
    }
	return $treeArray;
}

//Check if table exists
function check_if_table_exists($table_name, $conn){
	$checktable = mysql_query("SHOW TABLES LIKE '$table_name'");
	if(mysql_num_rows($checktable) <= 0){
		echo ('Cannot find ' . $tbale_name . ' table: ' . mysql_error());
	}
}

}



?>